#INCLUDE "PJXEX_VFX.h"
#INCLUDE "../prgs/main.h"

*******************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_PJXEX_VFX",lcCollate)

****************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_PJXEX_VFX_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_PJXEX_VFX_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)

****************************************************************************
DEFINE CLASS _PJXEX_VFX AS _pdm_PlugIn && 
   Name="_PJXEX_VFX"

   ID=500         && ID of Plug-in
   Type="PJXEX" && 

   Alias=""

   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "VFX Project Properties")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetSource, "Source File")
         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC


   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lcHTML,lcClassLibF,lcClassLib,lcClass,m.Classloc,m.Class

      IF !USED(This.Alias)
         RETURN ""
      ENDIF

      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      lcHTML=""

      lcHTML=lcHTML+;
             [<table class="pjxex_vfx_Table" border="1">]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[<thead>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr class="pjxex_vfx_Head">]+;
             [<td>]+This.GetHTMLString(PI_HTML_BaseClass)+[</td>]+;
             [<td>]+This.GetHTMLString(PI_HTML_Class)+[</td>]+;
             [<td>]+This.GetHTMLString(PI_HTML_ClassLoc)+[</td>]+;
             [<td>]+This.GetHTMLString(PI_HTML_FieldType)+[</td>]+;
             m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[</thead>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[<tbody>]+m.loPDM.aSpace(21)

      SELE (This.Alias)
      SCAN ALL
           m.Classloc=ALLT(CLASSLIB)
           m.Class=ALLT(CLASS)
           lcClassLibF=IIF(!EMPTY(m.Classloc),;
                       FULLPATH(m.Classloc,;
                         IIF(m.loPDM.SourceType=1,ExtractPathFromFile(m.loPDM.PJXFile),m.loPDM.DefaultFolder)),"")

           lcClassLib=m.loPDMs.GetClassAnchor(m.lcClassLibF,"","../")
           lcClass=m.loPDMs.GetClassAnchor(m.lcClassLibF,m.Class,"../")

*                  [<td>]+ALLT(BASECLASS)+[</td>]+;

           lcHTML=lcHTML+;
                  m.loPDM.aSpace(2)+[<tr>]+;
                  [<td>&nbsp;</td>]+;
                  [<td>]+IIF(EMPTY(m.lcClass),m.Class,'<a href="'+m.lcClass+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",LOWER(m.Class))+'">'+m.Class+'</a>')+[</td>]+;
                  [<td>]+IIF(EMPTY(m.lcClassLib),m.Classloc,'<a href="'+m.lcClassLib+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05113),"%name%",LOWER(m.Classloc))+'">'+m.Classloc+'</a>')+[</td>]+;
                  [<td>]+TYPE+[</td>]+;
                  m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21)
      ENDSCAN

      lcHTML=lcHTML+;
             m.loPDM.aSpace(1)+[</tbody>]+m.loPDM.aSpace(21)+[</table>]+m.loPDM.aSpace(21)

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_PJXEX_VFX_par")
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.Source=GetINIString(lcSection,"Source",loSettings.Source,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"Source",ALLT(loSettings.Source),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      loDst.CSS=loSrc.CSS
      loDst.Source =loSrc.Source
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn,loPDM
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            SELE (This.AHTML)
            SET ORDER TO "I01"
            llEn=.F.
         ENDIF

         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_BaseClass, "Base Class")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Class, "Class")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Classloc, "Class Library")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_FieldType, "Field Type")
            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF

      * Open table with META Data
      IF !EMPTY(loSetting.Source)
         This.Alias=SYS(2015)
         RETURN loPDMs.OpenTable(This.DataSessionID,;
                IIF(AT("\\",loSetting.Source)>0 OR AT(":",loSetting.Source)>0,"",IIF(loPDM.SourceType=1,ExtractPathFromFile(loPDM.PJXFile),loPDM.DefaultFolder))+loSetting.Source,;
                This.Alias,"NOUPDATE")=0
      ENDIF

      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      IF USED(This.Alias)
         USE IN (This.Alias)
      ENDIF
      RETURN .T.
   ENDPROC


ENDDEFINE

***********************************************************
DEFINE CLASS _PJXEX_VFX_par AS custom
   Name="_PJXEX_VFX_par"
   DIME aCSS(1),aJS(1)

   OK=.F.

   Source="VFXclass.dbf" && Relative to Project...
 
   CSS="PJXEX_VFX.css" && Relative to PJXEX_VFX.fxp
   JS="" && 

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE
